# Ошибки API

## Введение

В данном документе описаны ошибки, которые могут возникнуть при работе с API. \
Ошибки делятся на две категории: общие ошибки и ошибки конкретных методов. \
Общие ошибки могут возникнуть при работе с любым методом, а ошибки конкретных методов - только при работе с соответствующими методами. \
Каждая ошибка имеет свой код и описание. \
Код ошибки - это уникальный идентификатор ошибки, который можно использовать для обработки ошибок в программе. \
Описание ошибки - это текстовое описание ошибки, которое можно показать пользователю.

Пример ошибки:

```json
{
    "error": {
        "code": 1,
        "message": "Invalid token"
    }
}
```

## Общие ошибки

| Код | Описание            |
|:---:|:--------------------|
|  1  | Invalid API version |

### Ошибки аутентификации

| Код | Описание                       |
|:---:|:-------------------------------|
| 10  | Invalid token                  |
| 11  | Token expired                  |
| 12  | Login or password is incorrect |

### Ошибки доступа

| Код | Описание      |
|:---:|:--------------|
| 20  | Access denied |

### Ошибки аргументов

| Код | Описание                  |
|:---:|:--------------------------|
| 30  | Missing required argument |
| 31  | Invalid argument value    |
| 32  | Invalid argument type     |
| 33  | Invalid argument format   |

### Ошибки методов

| Код | Описание           |
|:---:|:-------------------|
| 40  | Method Not Found   |
| 41  | Method Not Allowed |


### Ошибки сервера

| Код | Описание                  |
|:---:|:--------------------------|
| 50  | Internal server error     |

## Ошибки методов


### Modpacks

| Код | Описание               | Методы                                                              |
|:---:|:-----------------------|:--------------------------------------------------------------------|
| 100 | Modpack not found      | - `modpacks.update`<br/>- `modpacks.get*`<br/> - `modpacks.delete*` |
| 101 | Modpack already exists | - `modpacks.create`                                                 |
| 102 | Version not found      | - `modpacks.deleteVersion`<br/>- `modpacks.getMods`                 |

